public class ServerGUI extends javax.swing.JFrame implements java.awt.event.ActionListener
{

    private final static String serverTag = "[Server] ";
    private final static String serverName = "P16 Blitz Gui Panel";

    public ServerGUI()
    {
        initComponents();
    }

    public static void addConsole(String consoleText, boolean consoleTag)
    {
        if(consoleTag)
            serverConsole.append(serverTag + consoleText + newLine);
    }

    public void addConsole(String consoleText)
    {
        serverConsole.append(consoleText + newLine);
    }

    private void initComponents()
    {
        serverConsoleScroll = new javax.swing.JScrollPane();
        serverConsole = new javax.swing.JTextArea();
        serverUsersScroll = new javax.swing.JScrollPane();
        serverUsers = new javax.swing.JList();
        serverCommandPanel = new javax.swing.JPanel();
	  serverCheckbox = new javax.swing.JPanel();
        serverCommand = new javax.swing.JTextField();
        serverCommandExecute = new javax.swing.JButton();
	  serverSnow = new javax.swing.JCheckBox("Snow ON/OFF",false);
	  serverSnow.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                serverSnowActionPerformed(evt);

            }
        });
serverReset = new javax.swing.JCheckBox("Reset ON/OFF",false);
	serverReset.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                serverResetActionPerformed(evt);

            }
        });

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        setTitle("P16 Blitz Gui Panel--\u00a9--Wolf");
        setAlwaysOnTop(false);
        setCursor(new java.awt.Cursor(java.awt.Cursor.DEFAULT_CURSOR));
        setFont(new java.awt.Font("Arial", 1, 10));
        setMaximizedBounds(new java.awt.Rectangle(0, 0, 400, 150));
        setName("serverWindow");
        setResizable(true);
        serverConsoleScroll.setHorizontalScrollBarPolicy(javax.swing.ScrollPaneConstants.HORIZONTAL_SCROLLBAR_NEVER);
        serverConsoleScroll.setVerticalScrollBarPolicy(javax.swing.ScrollPaneConstants.VERTICAL_SCROLLBAR_ALWAYS);
        serverConsoleScroll.setAutoscrolls(true);
        serverConsole.setColumns(35);
        serverConsole.setEditable(false);
        serverConsole.setFont(new java.awt.Font("Tahoma", 0, 12));
        serverConsole.setRows(9);

        serverConsole.setBorder(new javax.swing.border.EtchedBorder(null, new java.awt.Color(170, 0, 0))); //102, 102, 102
        serverConsoleScroll.setViewportView(serverConsole);

        getContentPane().add(serverConsoleScroll, java.awt.BorderLayout.WEST);

        serverUsersScroll.setVerticalScrollBarPolicy(javax.swing.ScrollPaneConstants.VERTICAL_SCROLLBAR_ALWAYS);
        serverUsers.setBorder(new javax.swing.border.EtchedBorder(null, new java.awt.Color(170, 0, 0)));//102, 102, 102
        serverUsers.setModel(new javax.swing.AbstractListModel()
        {
            String[] strings = {"Wolf", "", "", "", "", "", "", "", "", "", "", "", "",
                "", "", "", "", ""};
            public int getSize()
            {
                return strings.length;
            }

            public Object getElementAt(int i)
            {
                return strings[i];
            }
        });
        serverUsers.setSelectionMode(javax.swing.ListSelectionModel.SINGLE_SELECTION);
        serverUsers.setPreferredSize(new java.awt.Dimension(100, 1));
        serverUsers.setVisibleRowCount(3);
        serverUsersScroll.setViewportView(serverUsers);

        getContentPane().add(serverUsersScroll, java.awt.BorderLayout.CENTER);

        serverCommandPanel.setBackground(new java.awt.Color(227, 227, 225));
        serverCommand.setColumns(34);
        serverCommand.setText("Please Enter A Command");
        serverCommand.setBorder(new javax.swing.border.EtchedBorder(null, new java.awt.Color(170, 0, 0)));//102, 102, 102
        serverCommand.setMinimumSize(new java.awt.Dimension(20, 50));
        serverCommand.addActionListener(this);
	serverCheckbox.setBackground(new java.awt.Color(227, 227, 225));
        serverCommandPanel.add(serverCommand);
	serverCheckbox.add(serverSnow);
	serverCheckbox.add(serverReset);
        serverCommandExecute.setText("Execute");
        serverCommandExecute.addActionListener(this);
        serverCommandPanel.add(serverCommandExecute);
	getContentPane().add(serverCheckbox, java.awt.BorderLayout.EAST);
	
        getContentPane().add(serverCommandPanel, java.awt.BorderLayout.SOUTH);

        pack();
		}
	private void serverSnowActionPerformed(java.awt.event.ActionEvent evt) {
	if (serverSnow.isSelected())
	{
		misc.printlnTag("Enabling Snow");
		client.snow = true;
	}
	else
	{
		misc.printlnTag("Disabling Snow");
		client.snow = false;
	}

	}
	private void serverResetActionPerformed(java.awt.event.ActionEvent evt) {
	if (serverReset.isSelected())
	{
		misc.printlnTag("Server Reset Turned ON");
		ReTT.restart = true;
	}
	else
	{
		misc.printlnTag("Server Reset Turned OFF");
		ReTT.restart = false;
	}

	}
    public void actionPerformed(java.awt.event.ActionEvent evt)
    {
        String gsc = serverCommand.getText();
        gsc = gsc.toLowerCase();
        boolean used = true;
        if(gsc.startsWith("msg ")){
            misc.printlnTag("[Server] " + gsc.substring(4));
            PlayerHandler.messageToAll = "[Server] " + gsc.substring(4);
        }
        else if(gsc.startsWith("snow ")){
            boolean val = gsc.substring(5).equalsIgnoreCase("on");
            serverSnow.setSelected(true);
            misc.printlnTag("Turning Snow " + (val ? "on" : "off"));
            //client.snow = val;
            //if(client.snow == false)
            {
				serverSnow.setSelected(false);
			}

        }
        else if(gsc.startsWith("bootall")){
            PlayerHandler.kickAllPlayers = true;
        }
        else if(gsc.startsWith("kick ")){
			String nick = gsc.substring(5);
            PlayerHandler.kickNick = gsc.substring(5);
            PlayerHandler.messageToAll = "[server] is Kicking Player: " + gsc.substring(5);
            misc.printlnTag("Player " + nick + " kicked");
        }
	  else if(gsc.startsWith("ban ")){
		String victim = gsc.substring(4);
            PlayerHandler.kickNick = victim;
            PlayerHandler.messageToAll = "[server] is BANNING: " + gsc.substring(4);
		//the appendtoban thing here
        }
        else if(gsc.startsWith("update ")){
            PlayerHandler.updateSeconds = (Integer.parseInt(gsc.substring(7)) + 1);
            PlayerHandler.updateAnnounced = false;
            PlayerHandler.updateRunning = true;
            PlayerHandler.updateStartTime = System.currentTimeMillis();
        }
        else if(gsc.startsWith("restart ")){
            boolean val = gsc.substring(8).equalsIgnoreCase("on");
            ReTT.restart = val;
            misc.printlnTag("restart " + (val ? "ON" : "OFF"));
        }
        else if(gsc.startsWith("ipban ")){
            String name = gsc.substring(6);
            if(BanHandler.isBanned(name)){
                misc.printlnTag("player is already banned");
                serverCommand.setText("");
                return;
            }
            if(PlayerHandler.isPlayerOn(name)){
                PlayerHandler.kickNick = name;
                PlayerHandler.messageToAll = "[server] is IP-Banning Player: " + name;
                misc.printlnTag("player kicked");
            }
            Player[] players = PlayerHandler.players;
            for(int i = 0; i < players.length; i++)
                if(players[i] != null && players[i].playerName.equalsIgnoreCase(name)){
                    try{
                        BanHandler.unBan(java.net.InetAddress.getByName(players[i].connectedFrom));
                        misc.printlnTag("unbanned player");
                    }
                    catch(Exception e){
                        e.printStackTrace();
                    }
                }
        }
        else if(gsc.startsWith("unban ")){
            if(!BanHandler.isBanned(gsc.substring(6))){
                misc.printlnTag("player isn't banned");
                serverCommand.setText("");
                return;
            }
            BanHandler.unBan(gsc.substring(6));
            misc.printlnTag("player unbanned");
        } //Unbanning IP-Banned people will have to be done manually =\
        else
            used = false;
        if(used)
            serverCommand.setText("");
        else
            misc.printlnTag("Unknown Command: " + gsc.split(" ")[0]);
    }

    public static void main()
    {
        java.awt.EventQueue.invokeLater(new Runnable()
        {
            public void run()
            {
                new ServerGUI().setVisible(true);
            }
        });
    }

    private final static String newLine = "\n";

    private javax.swing.JTextField serverCommand;
    private javax.swing.JButton serverCommandExecute;
    private javax.swing.JPanel serverCommandPanel;
    private javax.swing.JPanel serverCheckbox;
    private static javax.swing.JTextArea serverConsole;
    private javax.swing.JScrollPane serverConsoleScroll;
    private javax.swing.JList serverUsers;
    private javax.swing.JScrollPane serverUsersScroll;
    private javax.swing.JCheckBox serverSnow;
    private javax.swing.JCheckBox serverReset;
}
